/******************************************************************************
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2010-2022 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * This header file was automatically generated by:
 *
 *     /builddir/build/BUILD/cvc5-cvc5-1.0.8/src/expr/mkkind /builddir/build/BUILD/cvc5-cvc5-1.0.8/src/expr/kind_template.h /builddir/build/BUILD/cvc5-cvc5-1.0.8/src/theory/builtin/kinds /builddir/build/BUILD/cvc5-cvc5-1.0.8/src/theory/booleans/kinds /builddir/build/BUILD/cvc5-cvc5-1.0.8/src/theory/uf/kinds /builddir/build/BUILD/cvc5-cvc5-1.0.8/src/theory/arith/kinds /builddir/build/BUILD/cvc5-cvc5-1.0.8/src/theory/bv/kinds /builddir/build/BUILD/cvc5-cvc5-1.0.8/src/theory/ff/kinds /builddir/build/BUILD/cvc5-cvc5-1.0.8/src/theory/fp/kinds /builddir/build/BUILD/cvc5-cvc5-1.0.8/src/theory/arrays/kinds /builddir/build/BUILD/cvc5-cvc5-1.0.8/src/theory/datatypes/kinds /builddir/build/BUILD/cvc5-cvc5-1.0.8/src/theory/sep/kinds /builddir/build/BUILD/cvc5-cvc5-1.0.8/src/theory/sets/kinds /builddir/build/BUILD/cvc5-cvc5-1.0.8/src/theory/bags/kinds /builddir/build/BUILD/cvc5-cvc5-1.0.8/src/theory/strings/kinds /builddir/build/BUILD/cvc5-cvc5-1.0.8/src/theory/quantifiers/kinds
 *
 * for the cvc5 project.
 */

/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */

/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */
/* THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT ! */

/* Edit the template file instead:                     */
/* /builddir/build/BUILD/cvc5-cvc5-1.0.8/src/expr/kind_template.h */

/******************************************************************************
 * Top contributors (to current version):
 *   Andres Noetzli, Mathias Preiner, Aina Niemetz
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2023 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Template for the Node kind header.
 */

#include "cvc5_public.h"

#ifndef CVC5__KIND_H
#define CVC5__KIND_H

#include <iosfwd>

#include "base/exception.h"
#include "theory/theory_id.h"

namespace cvc5::internal {
namespace kind {

enum Kind_t
{
  UNDEFINED_KIND = -1, /**< undefined */
  NULL_EXPR,           /**< Null kind */
  // clang-format off
  
  /* from builtin */
  SORT_TYPE, /**< specifies types of user-declared 'uninterpreted' sorts (1) */
  INSTANTIATED_SORT_TYPE, /**< instantiated uninterpreted sort (2) */
  UNINTERPRETED_SORT_VALUE, /**< util/uninterpreted_sort_value.h (3) */
  BUILTIN, /**< expr/kind.h (4) */
  EQUAL, /**< equality (two parameters only, sorts must match) (5) */
  DISTINCT, /**< disequality (N-ary, sorts must match) (6) */
  VARIABLE, /**< a variable (not permitted in bindings) (7) */
  BOUND_VARIABLE, /**< a bound variable (permitted in bindings and the associated lambda and quantifier bodies only) (8) */
  SKOLEM, /**< a Skolem variable (internal only) (9) */
  SEXPR, /**< a symbolic expression (any arity) (10) */
  WITNESS, /**< a witness expression; first parameter is a BOUND_VAR_LIST, second is the witness body (11) */
  TYPE_CONSTANT, /**< expr/kind.h (12) */
  RAW_SYMBOL, /**< a variable that is not quoted in the smt2 printer (internal only) (13) */
  ABSTRACT_TYPE, /**< theory/builtin/abstract_type.h (14) */
  APPLY_INDEXED_SYMBOLIC_OP, /**< theory/builtin/generic_op.h (15) */
  APPLY_INDEXED_SYMBOLIC, /**< generic indexed operator, whose arguments are the list of terms corresponding to (symbolic) indices to the operator followed by its normal arguments (16) */

  /* from booleans */
  CONST_BOOLEAN, /**< util/bool.h (17) */
  NOT, /**< logical not (18) */
  AND, /**< logical and (N-ary) (19) */
  IMPLIES, /**< logical implication (exactly two parameters) (20) */
  OR, /**< logical or (N-ary) (21) */
  XOR, /**< exclusive or (exactly two parameters) (22) */
  ITE, /**< if-then-else, used for both Boolean and term ITE constructs; first parameter is (Boolean-sorted) condition, second is 'then', third is 'else' and these two parameters must have same base sort (23) */

  /* from uf */
  APPLY_UF, /**< application of an uninterpreted function; first parameter is the function, remaining ones are parameters to that function (24) */
  FUNCTION_TYPE, /**< a function type (25) */
  LAMBDA, /**< a lambda expression; first parameter is a BOUND_VAR_LIST, second is lambda body (26) */
  HO_APPLY, /**< higher-order (partial) function application (27) */
  CARDINALITY_CONSTRAINT_OP, /**< expr/cardinality_constraint.h (28) */
  CARDINALITY_CONSTRAINT, /**< a fixed upper bound on the cardinality of an uninterpreted sort (29) */
  COMBINED_CARDINALITY_CONSTRAINT_OP, /**< expr/cardinality_constraint.h (30) */
  COMBINED_CARDINALITY_CONSTRAINT, /**< a fixed upper bound on the sum of cardinalities of uninterpreted sorts (31) */
  FUNCTION_ARRAY_CONST, /**< expr/function_array_const.h (32) */
  BITVECTOR_TO_NAT, /**< bit-vector conversion to (nonnegative) integer; parameter is a bit-vector (33) */
  INT_TO_BITVECTOR_OP, /**< util/bitvector.h (34) */
  INT_TO_BITVECTOR, /**< integer conversion to bit-vector; first parameter is an INT_TO_BITVECTOR_OP, second is an integer term (35) */

  /* from arith */
  ADD, /**< arithmetic addition (N-ary) (36) */
  MULT, /**< arithmetic multiplication (N-ary) (37) */
  NONLINEAR_MULT, /**< synonym for MULT (38) */
  SUB, /**< arithmetic binary subtraction operator (39) */
  NEG, /**< arithmetic unary negation (40) */
  DIVISION, /**< real division, division by 0 undefined (user symbol) (41) */
  DIVISION_TOTAL, /**< real division with interpreted division by 0 (internal symbol) (42) */
  INTS_DIVISION, /**< integer division, division by 0 undefined (user symbol) (43) */
  INTS_DIVISION_TOTAL, /**< integer division with interpreted division by 0 (internal symbol) (44) */
  INTS_MODULUS, /**< integer modulus, division by 0 undefined (user symbol) (45) */
  INTS_MODULUS_TOTAL, /**< integer modulus with interpreted division by 0 (internal symbol) (46) */
  ABS, /**< absolute value (47) */
  DIVISIBLE, /**< divisibility-by-k predicate; first parameter is a DIVISIBLE_OP, second is integer term (48) */
  POW, /**< arithmetic power (49) */
  POW2, /**< arithmetic power of 2 (50) */
  EXPONENTIAL, /**< exponential (51) */
  SINE, /**< sine (52) */
  COSINE, /**< consine (53) */
  TANGENT, /**< tangent (54) */
  COSECANT, /**< cosecant (55) */
  SECANT, /**< secant (56) */
  COTANGENT, /**< cotangent (57) */
  ARCSINE, /**< arc sine (58) */
  ARCCOSINE, /**< arc consine (59) */
  ARCTANGENT, /**< arc tangent (60) */
  ARCCOSECANT, /**< arc cosecant (61) */
  ARCSECANT, /**< arc secant (62) */
  ARCCOTANGENT, /**< arc cotangent (63) */
  SQRT, /**< square root (64) */
  DIVISIBLE_OP, /**< util/divisible.h (65) */
  CONST_RATIONAL, /**< util/rational.h (66) */
  CONST_INTEGER, /**< util/rational.h (67) */
  REAL_ALGEBRAIC_NUMBER_OP, /**< util/real_algebraic_number.h (68) */
  REAL_ALGEBRAIC_NUMBER, /**< a real algebraic number constant; payload is an instance of the cvc5::internal::RealAlgebraicNumber class (69) */
  LT, /**< less than, x < y (70) */
  LEQ, /**< less than or equal, x <= y (71) */
  GT, /**< greater than, x > y (72) */
  GEQ, /**< greater than or equal, x >= y (73) */
  INDEXED_ROOT_PREDICATE_OP, /**< util/indexed_root_predicate.h (74) */
  INDEXED_ROOT_PREDICATE, /**< indexed root predicate; first parameter is a INDEXED_ROOT_PREDICATE_OP, second is a real variable compared to zero, third is a polynomial (75) */
  IS_INTEGER, /**< term-is-integer predicate (parameter is a real-sorted term) (76) */
  TO_INTEGER, /**< convert term to integer by the floor function (parameter is a real-sorted term) (77) */
  TO_REAL, /**< cast term to real (parameter is an integer-sorted term) (78) */
  PI, /**< pi (79) */
  IAND_OP, /**< util/iand.h (80) */
  IAND, /**< integer version of AND operator; first parameter is an IAND_OP, second and third are integer terms (81) */

  /* from bv */
  BITVECTOR_TYPE, /**< util/bitvector.h (82) */
  CONST_BITVECTOR, /**< util/bitvector.h (83) */
  BITVECTOR_BB_TERM, /**< create bit-vector from vector of Booleans (84) */
  BITVECTOR_CONCAT, /**< concatenation of two or more bit-vectors (85) */
  BITVECTOR_AND, /**< bitwise and of two or more bit-vectors (86) */
  BITVECTOR_COMP, /**< equality comparison of two bit-vectors (returns one bit) (87) */
  BITVECTOR_OR, /**< bitwise or of two or more bit-vectors (88) */
  BITVECTOR_XOR, /**< bitwise xor of two or more bit-vectors (89) */
  BITVECTOR_NOT, /**< bitwise not of a bit-vector (90) */
  BITVECTOR_NAND, /**< bitwise nand of two bit-vectors (91) */
  BITVECTOR_NOR, /**< bitwise nor of two bit-vectors (92) */
  BITVECTOR_XNOR, /**< bitwise xnor of two bit-vectors (93) */
  BITVECTOR_MULT, /**< multiplication of two or more bit-vectors (94) */
  BITVECTOR_NEG, /**< unary negation of a bit-vector (95) */
  BITVECTOR_ADD, /**< addition of two or more bit-vectors (96) */
  BITVECTOR_SUB, /**< subtraction of two bit-vectors (97) */
  BITVECTOR_UDIV, /**< unsigned division of two bit-vectors, truncating towards 0 (defined to be the all-ones bit pattern, if divisor is 0) (98) */
  BITVECTOR_UREM, /**< unsigned remainder from truncating division of two bit-vectors (defined to be equal to the dividend, if divisor is 0) (99) */
  BITVECTOR_SDIV, /**< 2's complement signed division (100) */
  BITVECTOR_SMOD, /**< 2's complement signed remainder (sign follows divisor) (101) */
  BITVECTOR_SREM, /**< 2's complement signed remainder (sign follows dividend) (102) */
  BITVECTOR_ASHR, /**< bit-vector arithmetic shift right (the two bit-vector parameters must have same width) (103) */
  BITVECTOR_LSHR, /**< bit-vector logical shift right (the two bit-vector parameters must have same width) (104) */
  BITVECTOR_SHL, /**< bit-vector shift left (the two bit-vector parameters must have same width) (105) */
  BITVECTOR_ULE, /**< bit-vector unsigned less than or equal (the two bit-vector parameters must have same width) (106) */
  BITVECTOR_ULT, /**< bit-vector unsigned less than (the two bit-vector parameters must have same width) (107) */
  BITVECTOR_UGE, /**< bit-vector unsigned greater than or equal (the two bit-vector parameters must have same width) (108) */
  BITVECTOR_UGT, /**< bit-vector unsigned greater than (the two bit-vector parameters must have same width) (109) */
  BITVECTOR_SLE, /**< bit-vector signed less than or equal (the two bit-vector parameters must have same width) (110) */
  BITVECTOR_SLT, /**< bit-vector signed less than (the two bit-vector parameters must have same width) (111) */
  BITVECTOR_SGE, /**< bit-vector signed greater than or equal (the two bit-vector parameters must have same width) (112) */
  BITVECTOR_SGT, /**< bit-vector signed greater than (the two bit-vector parameters must have same width) (113) */
  BITVECTOR_ULTBV, /**< bit-vector unsigned less than but returns bv of size 1 instead of boolean (114) */
  BITVECTOR_SLTBV, /**< bit-vector signed less than but returns bv of size 1 instead of boolean (115) */
  BITVECTOR_REDAND, /**< bit-vector redand (116) */
  BITVECTOR_REDOR, /**< bit-vector redor (117) */
  BITVECTOR_UADDO, /**< bit-vector unsigned addition overflow predicate (118) */
  BITVECTOR_SADDO, /**< bit-vector signed addition overflow predicate (119) */
  BITVECTOR_UMULO, /**< bit-vector unsigned multiplication overflow predicate (120) */
  BITVECTOR_SMULO, /**< bit-vector signed multiplication overflow predicate (121) */
  BITVECTOR_USUBO, /**< bit-vector unsigned subtraction overflow predicate (122) */
  BITVECTOR_SSUBO, /**< bit-vector signed subtraction overflow predicate (123) */
  BITVECTOR_SDIVO, /**< bit-vector signed division overflow predicate (124) */
  BITVECTOR_ITE, /**< same semantics as regular ITE, but condition is bv of size 1 instead of Boolean (125) */
  BITVECTOR_ACKERMANNIZE_UDIV, /**< term to be treated as a variable; used for eager bit-blasting Ackermann expansion of bvudiv (internal-only symbol) (126) */
  BITVECTOR_ACKERMANNIZE_UREM, /**< term to be treated as a variable; used for eager bit-blasting Ackermann expansion of bvurem (internal-only symbol) (127) */
  BITVECTOR_EAGER_ATOM, /**< formula to be treated as a bv atom via eager bit-blasting (internal-only symbol) (128) */
  BITVECTOR_BITOF_OP, /**< util/bitvector.h (129) */
  BITVECTOR_BITOF, /**< bit-vector boolean bit extract; first parameter is a BITVECTOR_BITOF_OP, second is a bit-vector term (130) */
  BITVECTOR_EXTRACT_OP, /**< util/bitvector.h (131) */
  BITVECTOR_EXTRACT, /**< bit-vector extract; first parameter is a BITVECTOR_EXTRACT_OP, second is a bit-vector term (132) */
  BITVECTOR_REPEAT_OP, /**< util/bitvector.h (133) */
  BITVECTOR_REPEAT, /**< bit-vector repeat; first parameter is a BITVECTOR_REPEAT_OP, second is a bit-vector term (134) */
  BITVECTOR_ROTATE_LEFT_OP, /**< util/bitvector.h (135) */
  BITVECTOR_ROTATE_LEFT, /**< bit-vector rotate left; first parameter is a BITVECTOR_ROTATE_LEFT_OP, second is a bit-vector term (136) */
  BITVECTOR_ROTATE_RIGHT_OP, /**< util/bitvector.h (137) */
  BITVECTOR_ROTATE_RIGHT, /**< bit-vector rotate right; first parameter is a BITVECTOR_ROTATE_RIGHT_OP, second is a bit-vector term (138) */
  BITVECTOR_SIGN_EXTEND_OP, /**< util/bitvector.h (139) */
  BITVECTOR_SIGN_EXTEND, /**< bit-vector sign-extend; first parameter is a BITVECTOR_SIGN_EXTEND_OP, second is a bit-vector term (140) */
  BITVECTOR_ZERO_EXTEND_OP, /**< util/bitvector.h (141) */
  BITVECTOR_ZERO_EXTEND, /**< bit-vector zero-extend; first parameter is a BITVECTOR_ZERO_EXTEND_OP, second is a bit-vector term (142) */

  /* from ff */
  FINITE_FIELD_TYPE, /**< util/finite_field_value.h (143) */
  CONST_FINITE_FIELD, /**< util/finite_field_value.h (144) */
  FINITE_FIELD_MULT, /**< multiplication of two or more field elements (145) */
  FINITE_FIELD_NEG, /**< unary negation of a field element (146) */
  FINITE_FIELD_ADD, /**< addition of two or more field elements (147) */

  /* from fp */
  CONST_FLOATINGPOINT, /**< util/floatingpoint.h (148) */
  CONST_ROUNDINGMODE, /**< util/roundingmode.h (149) */
  FLOATINGPOINT_TYPE, /**< util/floatingpoint.h (150) */
  FLOATINGPOINT_FP, /**< construct a floating-point literal from bit vectors (151) */
  FLOATINGPOINT_EQ, /**< floating-point equality (152) */
  FLOATINGPOINT_ABS, /**< floating-point absolute value (153) */
  FLOATINGPOINT_NEG, /**< floating-point negation (154) */
  FLOATINGPOINT_ADD, /**< floating-point addition (155) */
  FLOATINGPOINT_SUB, /**< floating-point sutraction (156) */
  FLOATINGPOINT_MULT, /**< floating-point multiply (157) */
  FLOATINGPOINT_DIV, /**< floating-point division (158) */
  FLOATINGPOINT_FMA, /**< floating-point fused multiply and add (159) */
  FLOATINGPOINT_SQRT, /**< floating-point square root (160) */
  FLOATINGPOINT_REM, /**< floating-point remainder (161) */
  FLOATINGPOINT_RTI, /**< floating-point round to integral (162) */
  FLOATINGPOINT_MIN, /**< floating-point minimum (163) */
  FLOATINGPOINT_MAX, /**< floating-point maximum (164) */
  FLOATINGPOINT_MIN_TOTAL, /**< floating-point minimum (defined for all inputs) (165) */
  FLOATINGPOINT_MAX_TOTAL, /**< floating-point maximum (defined for all inputs) (166) */
  FLOATINGPOINT_LEQ, /**< floating-point less than or equal (167) */
  FLOATINGPOINT_LT, /**< floating-point less than (168) */
  FLOATINGPOINT_GEQ, /**< floating-point greater than or equal (169) */
  FLOATINGPOINT_GT, /**< floating-point greater than (170) */
  FLOATINGPOINT_IS_NORMAL, /**< floating-point is normal (171) */
  FLOATINGPOINT_IS_SUBNORMAL, /**< floating-point is sub-normal (172) */
  FLOATINGPOINT_IS_ZERO, /**< floating-point is zero (173) */
  FLOATINGPOINT_IS_INF, /**< floating-point is infinite (174) */
  FLOATINGPOINT_IS_NAN, /**< floating-point is NaN (175) */
  FLOATINGPOINT_IS_NEG, /**< floating-point is negative (176) */
  FLOATINGPOINT_IS_POS, /**< floating-point is positive (177) */
  FLOATINGPOINT_TO_FP_FROM_IEEE_BV_OP, /**< util/floatingpoint.h (178) */
  FLOATINGPOINT_TO_FP_FROM_IEEE_BV, /**< convert an IEEE-754 bit vector to floating-point (179) */
  FLOATINGPOINT_TO_FP_FROM_FP_OP, /**< util/floatingpoint.h (180) */
  FLOATINGPOINT_TO_FP_FROM_FP, /**< convert between floating-point sorts (181) */
  FLOATINGPOINT_TO_FP_FROM_REAL_OP, /**< util/floatingpoint.h (182) */
  FLOATINGPOINT_TO_FP_FROM_REAL, /**< convert a real to floating-point (183) */
  FLOATINGPOINT_TO_FP_FROM_SBV_OP, /**< util/floatingpoint.h (184) */
  FLOATINGPOINT_TO_FP_FROM_SBV, /**< convert a signed bit vector to floating-point (185) */
  FLOATINGPOINT_TO_FP_FROM_UBV_OP, /**< util/floatingpoint.h (186) */
  FLOATINGPOINT_TO_FP_FROM_UBV, /**< convert an unsigned bit vector to floating-point (187) */
  FLOATINGPOINT_TO_UBV_OP, /**< util/floatingpoint.h (188) */
  FLOATINGPOINT_TO_UBV, /**< convert a floating-point value to an unsigned bit vector (189) */
  FLOATINGPOINT_TO_UBV_TOTAL_OP, /**< util/floatingpoint.h (190) */
  FLOATINGPOINT_TO_UBV_TOTAL, /**< convert a floating-point value to an unsigned bit vector (defined for all inputs) (191) */
  FLOATINGPOINT_TO_SBV_OP, /**< util/floatingpoint.h (192) */
  FLOATINGPOINT_TO_SBV, /**< convert a floating-point value to a signed bit vector (193) */
  FLOATINGPOINT_TO_SBV_TOTAL_OP, /**< util/floatingpoint.h (194) */
  FLOATINGPOINT_TO_SBV_TOTAL, /**< convert a floating-point value to a signed bit vector (defined for all inputs) (195) */
  FLOATINGPOINT_TO_REAL, /**< floating-point to real (196) */
  FLOATINGPOINT_TO_REAL_TOTAL, /**< floating-point to real (defined for all inputs) (197) */
  FLOATINGPOINT_COMPONENT_NAN, /**< NaN component of a word-blasted floating-point number (198) */
  FLOATINGPOINT_COMPONENT_INF, /**< Inf component of a word-blasted floating-point number (199) */
  FLOATINGPOINT_COMPONENT_ZERO, /**< Zero component of a word-blasted floating-point number (200) */
  FLOATINGPOINT_COMPONENT_SIGN, /**< Sign component of a word-blasted floating-point number (201) */
  FLOATINGPOINT_COMPONENT_EXPONENT, /**< Exponent component of a word-blasted floating-point number (202) */
  FLOATINGPOINT_COMPONENT_SIGNIFICAND, /**< Significand component of a word-blasted floating-point number (203) */
  ROUNDINGMODE_BITBLAST, /**< The bit-vector for a non-deterministic rounding mode (204) */

  /* from arrays */
  ARRAY_TYPE, /**< array type (205) */
  SELECT, /**< array select; first parameter is an array term, second is the selection index (206) */
  STORE, /**< array store; first parameter is an array term, second is the store index, third is the term to store at the index (207) */
  EQ_RANGE, /**< equality of two arrays over an index range lower/upper (208) */
  STORE_ALL, /**< expr/array_store_all.h (209) */
  ARRAY_LAMBDA, /**< array lambda (internal-only symbol) (210) */

  /* from datatypes */
  CONSTRUCTOR_TYPE, /**< constructor (211) */
  SELECTOR_TYPE, /**< selector (212) */
  TESTER_TYPE, /**< tester (213) */
  UPDATER_TYPE, /**< datatype update (214) */
  APPLY_CONSTRUCTOR, /**< constructor application; first parameter is the constructor, remaining parameters (if any) are parameters to the constructor (215) */
  APPLY_SELECTOR, /**< selector application; parameter is a datatype term (undefined if mis-applied) (216) */
  APPLY_TESTER, /**< tester application; first parameter is a tester, second is a datatype term (217) */
  APPLY_UPDATER, /**< datatype updater application; first parameter is an update, second is a datatype term to update, third is the value to update with (218) */
  DATATYPE_TYPE, /**<  (219) */
  PARAMETRIC_DATATYPE, /**< parametric datatype (220) */
  TUPLE_TYPE, /**< tuple type (221) */
  APPLY_TYPE_ASCRIPTION, /**< type ascription, for datatype constructor applications; first parameter is an ASCRIPTION_TYPE, second is the datatype constructor application being ascribed (222) */
  ASCRIPTION_TYPE, /**< expr/ascription_type.h (223) */
  DT_SIZE, /**< datatypes size (224) */
  DT_HEIGHT_BOUND, /**< datatypes height bound (225) */
  DT_SIZE_BOUND, /**< datatypes height bound (226) */
  DT_SYGUS_BOUND, /**< datatypes sygus bound (227) */
  DT_SYGUS_EVAL, /**< datatypes sygus evaluation function (228) */
  MATCH, /**< match construct (229) */
  MATCH_CASE, /**< a match case (230) */
  MATCH_BIND_CASE, /**< a match case with bound variables (231) */
  TUPLE_PROJECT_OP, /**< theory/datatypes/project_op.h (232) */
  TUPLE_PROJECT, /**< projects a tuple from an existing tuple using indices passed in TupleProjectOp (233) */
  CODATATYPE_BOUND_VARIABLE, /**< expr/codatatype_bound_variable.h (234) */

  /* from sep */
  SEP_NIL, /**< separation nil (235) */
  SEP_EMP, /**< separation logic empty heap constraint (236) */
  SEP_PTO, /**< points to relation (237) */
  SEP_STAR, /**< separation star (238) */
  SEP_WAND, /**< separation magic wand (239) */
  SEP_LABEL, /**< separation label (internal use only) (240) */

  /* from sets */
  SET_EMPTY, /**< expr/emptyset.h (241) */
  SET_TYPE, /**< set type, takes as parameter the type of the elements (242) */
  SET_UNION, /**< set union (243) */
  SET_INTER, /**< set intersection (244) */
  SET_MINUS, /**< set subtraction (245) */
  SET_SUBSET, /**< subset predicate; first parameter a subset of second (246) */
  SET_MEMBER, /**< set membership predicate; first parameter a member of second (247) */
  SET_SINGLETON, /**< constructs a set of a single element. First parameter is a term (248) */
  SET_INSERT, /**< set obtained by inserting elements (first N-1 parameters) into a set (the last parameter) (249) */
  SET_CARD, /**< set cardinality operator (250) */
  SET_COMPLEMENT, /**< set complement (with respect to finite universe) (251) */
  SET_UNIVERSE, /**< (finite) universe set, all set variables must be interpreted as subsets of it. (252) */
  SET_COMPREHENSION, /**< set comprehension specified by a bound variable list, a predicate, and a term. (253) */
  SET_CHOOSE, /**< return an element in the set given as a parameter (254) */
  SET_IS_SINGLETON, /**< return whether the given set is a singleton (255) */
  SET_MAP, /**< set map function (256) */
  SET_FILTER, /**< set filter operator (257) */
  SET_FOLD, /**< set fold operator (258) */
  RELATION_GROUP_OP, /**< theory/datatypes/project_op.h (259) */
  RELATION_GROUP, /**< relation group (260) */
  RELATION_AGGREGATE_OP, /**< theory/datatypes/project_op.h (261) */
  RELATION_AGGREGATE, /**< relation aggregate (262) */
  RELATION_PROJECT_OP, /**< theory/datatypes/project_op.h (263) */
  RELATION_PROJECT, /**< relation projection (264) */
  RELATION_JOIN, /**< relation join (265) */
  RELATION_PRODUCT, /**< relation cartesian product (266) */
  RELATION_TRANSPOSE, /**< relation transpose (267) */
  RELATION_TCLOSURE, /**< relation transitive closure (268) */
  RELATION_JOIN_IMAGE, /**< relation join image (269) */
  RELATION_IDEN, /**< relation identity (270) */

  /* from bags */
  BAG_EMPTY, /**< expr/emptybag.h (271) */
  BAG_TYPE, /**< bag type, takes as parameter the type of the elements (272) */
  BAG_UNION_MAX, /**< union for bags (max) (273) */
  BAG_UNION_DISJOINT, /**< disjoint union for bags (sum) (274) */
  BAG_INTER_MIN, /**< bag intersection (min) (275) */
  BAG_DIFFERENCE_SUBTRACT, /**< bag difference1 (subtracts multiplicities) (276) */
  BAG_DIFFERENCE_REMOVE, /**< bag difference remove (removes shared elements) (277) */
  BAG_SUBBAG, /**< inclusion predicate for bags (less than or equal multiplicities) (278) */
  BAG_COUNT, /**< multiplicity of an element in a bag (279) */
  BAG_MEMBER, /**< bag membership predicate; is first parameter a member of second? (280) */
  BAG_DUPLICATE_REMOVAL, /**< eliminate duplicates in a bag (also known as the delta operator,or the squash operator) (281) */
  BAG_MAKE, /**< constructs a bag from one element along with its multiplicity (282) */
  BAG_IS_SINGLETON, /**< return whether the given bag is a singleton (283) */
  BAG_CARD, /**< bag cardinality operator (284) */
  BAG_FROM_SET, /**< converts a set to a bag (285) */
  BAG_TO_SET, /**< converts a bag to a set (286) */
  BAG_CHOOSE, /**< return an element in the bag given as a parameter (287) */
  BAG_MAP, /**< bag map function (288) */
  BAG_FILTER, /**< bag filter operator (289) */
  BAG_FOLD, /**< bag fold operator (290) */
  BAG_PARTITION, /**< bag partition operator (291) */
  TABLE_PRODUCT, /**< table cross product (292) */
  TABLE_PROJECT_OP, /**< theory/datatypes/project_op.h (293) */
  TABLE_PROJECT, /**< table projection (294) */
  TABLE_AGGREGATE_OP, /**< theory/datatypes/project_op.h (295) */
  TABLE_AGGREGATE, /**< table aggregate (296) */
  TABLE_JOIN_OP, /**< theory/datatypes/project_op.h (297) */
  TABLE_JOIN, /**< table join (298) */
  TABLE_GROUP_OP, /**< theory/datatypes/project_op.h (299) */
  TABLE_GROUP, /**< table group (300) */

  /* from strings */
  STRING_CONCAT, /**< string concat (N-ary) (301) */
  STRING_IN_REGEXP, /**< membership (302) */
  STRING_LENGTH, /**< string length (303) */
  STRING_SUBSTR, /**< string substr (304) */
  STRING_UPDATE, /**< string update (305) */
  STRING_CHARAT, /**< string charat (306) */
  STRING_CONTAINS, /**< string contains (307) */
  STRING_LT, /**< string less than (308) */
  STRING_LEQ, /**< string less than or equal (309) */
  STRING_INDEXOF, /**< string index of substring (310) */
  STRING_INDEXOF_RE, /**< string index of regular expression match (311) */
  STRING_REPLACE, /**< string replace (312) */
  STRING_REPLACE_ALL, /**< string replace all (313) */
  STRING_REPLACE_RE, /**< string replace regular expression match (314) */
  STRING_REPLACE_RE_ALL, /**< string replace all regular expression matches (315) */
  STRING_PREFIX, /**< string prefixof (316) */
  STRING_SUFFIX, /**< string suffixof (317) */
  STRING_IS_DIGIT, /**< string isdigit, returns true if argument is a string of length one that represents a digit (318) */
  STRING_ITOS, /**< integer to string (319) */
  STRING_STOI, /**< string to integer (total function) (320) */
  STRING_TO_CODE, /**< string to code, returns the code of the first character of the string if it has length one, -1 otherwise (321) */
  STRING_FROM_CODE, /**< string from code, returns a string containing a single character whose code point matches the argument to this function, empty string if the argument is not a valid code point (322) */
  STRING_UNIT, /**< string unit, returns a string containing a single character whose code point matches the argument to this function, arbitrary string of length one if the argument is not a valid code point (323) */
  STRING_TO_LOWER, /**< string to lowercase conversion (324) */
  STRING_TO_UPPER, /**< string to uppercase conversion (325) */
  STRING_REV, /**< string reverse (326) */
  CONST_STRING, /**< util/string.h (327) */
  SEQUENCE_TYPE, /**< seuence type, takes as parameter the type of the elements (328) */
  CONST_SEQUENCE, /**< expr/sequence.h (329) */
  SEQ_UNIT, /**< a sequence of length one. First parameter is a term (330) */
  SEQ_NTH, /**< The nth element of a sequence (331) */
  STRING_TO_REGEXP, /**< convert string to regexp (332) */
  REGEXP_CONCAT, /**< regexp concat (333) */
  REGEXP_UNION, /**< regexp union (334) */
  REGEXP_INTER, /**< regexp intersection (335) */
  REGEXP_DIFF, /**< regexp difference (336) */
  REGEXP_STAR, /**< regexp * (337) */
  REGEXP_PLUS, /**< regexp + (338) */
  REGEXP_OPT, /**< regexp ? (339) */
  REGEXP_RANGE, /**< regexp range (340) */
  REGEXP_COMPLEMENT, /**< regexp complement (341) */
  REGEXP_NONE, /**< regexp empty (342) */
  REGEXP_ALL, /**< regexp all (343) */
  REGEXP_ALLCHAR, /**< regexp all characters (344) */
  REGEXP_REPEAT_OP, /**< util/regexp.h (345) */
  REGEXP_REPEAT, /**< regular expression repeat; first parameter is a REGEXP_REPEAT_OP, second is a regular expression term (346) */
  REGEXP_LOOP_OP, /**< util/regexp.h (347) */
  REGEXP_LOOP, /**< regular expression loop; first parameter is a REGEXP_LOOP_OP, second is a regular expression term (348) */
  REGEXP_RV, /**< regexp rv (internal use only) (349) */

  /* from quantifiers */
  FORALL, /**< universally quantified formula; first parameter is an BOUND_VAR_LIST, second is quantifier body, and an optional third parameter is an INST_PATTERN_LIST (350) */
  EXISTS, /**< existentially quantified formula; first parameter is an BOUND_VAR_LIST, second is quantifier body, and an optional third parameter is an INST_PATTERN_LIST (351) */
  INST_CONSTANT, /**< instantiation constant (352) */
  ORACLE, /**< oracle (353) */
  BOUND_VAR_LIST, /**< a list of bound variables (used to bind variables under a quantifier) (354) */
  INST_PATTERN, /**< instantiation pattern (355) */
  INST_NO_PATTERN, /**< instantiation no-pattern (356) */
  INST_ATTRIBUTE, /**< instantiation attribute (357) */
  INST_POOL, /**< instantiation pool (358) */
  INST_ADD_TO_POOL, /**< instantiation add to pool (359) */
  SKOLEM_ADD_TO_POOL, /**< skolemization add to pool (360) */
  ORACLE_FORMULA_GEN, /**< oracle interface (361) */
  INST_PATTERN_LIST, /**< a list of instantiation patterns (362) */
 LAST_KIND /**< marks the upper-bound of this enumeration */
  // clang-format on

}; /* enum Kind_t */

}  // namespace kind

// import Kind into the "cvc5" namespace but keep the individual kind
// constants under kind::
typedef cvc5::internal::kind::Kind_t Kind;

namespace kind {

/**
 * Converts an kind to a string. Note: This function is also used in
 * `safe_print()`. Changing this functions name or signature will result in
 * `safe_print()` printing "<unsupported>" instead of the proper strings for
 * the enum values.
 *
 * @param k The kind
 * @return The name of the kind
 */
const char* toString(cvc5::internal::Kind k);

/**
 * Writes a kind name to a stream.
 *
 * @param out The stream to write to
 * @param k The kind to write to the stream
 * @return The stream
 */
std::ostream& operator<<(std::ostream&, cvc5::internal::Kind);

/** Returns true if the given kind is associative. This is used by ExprManager to
 * decide whether it's safe to modify big expressions by changing the grouping of
 * the arguments. */
/* TODO: This could be generated. */
bool isAssociative(cvc5::internal::Kind k);
std::string kindToString(cvc5::internal::Kind k);

struct KindHashFunction
{
  inline size_t operator()(cvc5::internal::Kind k) const { return k; }
}; /* struct KindHashFunction */

}  // namespace kind

/**
 * The enumeration for the built-in atomic types.
 */
enum TypeConstant
{
  // clang-format off
    BUILTIN_OPERATOR_TYPE, /**< the type for built-in operators */
  SEXPR_TYPE, /**< the type of a symbolic expression */
  BOOLEAN_TYPE, /**< Boolean type */
  REAL_TYPE, /**< real type */
  INTEGER_TYPE, /**< integer type */
  ROUNDINGMODE_TYPE, /**< floating-point rounding mode */
  STRING_TYPE, /**< String type */
  REGEXP_TYPE, /**< RegExp type */
  BOUND_VAR_LIST_TYPE, /**< the type of bound variable lists */
  INST_PATTERN_TYPE, /**< instantiation pattern type */
  INST_PATTERN_LIST_TYPE, /**< the type of instantiation pattern lists */
 LAST_TYPE
  // clang-format on
}; /* enum TypeConstant */

/**
 * We hash the constants with their values.
 */
struct TypeConstantHashFunction
{
  inline size_t operator()(TypeConstant tc) const { return tc; }
}; /* struct TypeConstantHashFunction */

const char* toString(TypeConstant tc);
std::ostream& operator<<(std::ostream& out, TypeConstant typeConstant);

namespace theory {

cvc5::internal::theory::TheoryId kindToTheoryId(cvc5::internal::Kind k);
cvc5::internal::theory::TheoryId typeConstantToTheoryId(
    cvc5::internal::TypeConstant typeConstant);

}  // namespace theory
}  // namespace cvc5::internal

#endif /* CVC5__KIND_H */
